--	UniTarget by Unique of the Lightning Troopers guild on Dalaran
--	Thanks to Meog, Jooky, Norganna, Sardonic, Woolfeist, Trentin whose code I've blatantly ripped in parts and learnt a lot from :).


UNITARGETVERSION = 0.1;
UNITARGETNAME = "Uni Target";
UNITARGETDESC = "Uni Target mod to allow click or keybind for target info";
UNITARGETFRAME = "UniTargetFrame";

SLASH_UNITARGET1 = "/UniTarget";

UNI_UNITARGETUSAGE_SUBCMD = {};
UNI_UNITARGETUSAGE_SUBCMD[1] = "Usage:";
UNI_UNITARGETUSAGE_SUBCMD[2] = "  |cffffffff/UniTarget target|r - Gives the instructions for the new targetting output side of the mod.";
--UNI_UNITARGETUSAGE_SUBCMD[3] = "  |cffffffff/UniTarget channel|r - Gives instructions for setting up which channel output.";
UNI_UNITARGETUSAGE_SUBCMD[3] = "  |cffffffff/UniTarget button|r - Gives the instructions for button-handling.";

UNI_UNITARGETCHANNEL_SUBCMD = {};
UNI_UNITARGETCHANNEL_SUBCMD[1] = "Usage:";
UNI_UNITARGETCHANNEL_SUBCMD[2] = "  |cffffffff/UniTarget channel party|r - Sets default to Party channel.";
UNI_UNITARGETCHANNEL_SUBCMD[3] = "  |cffffffff/UniTarget channel guild|r - Sets default to Guild channel.";
UNI_UNITARGETCHANNEL_SUBCMD[4] = "  |cffffffff/UniTarget channel <channelname>|r - Sets default to <channelname> channel.";




--  Configuration
UniTarget_NameRegistered = 0;
UniTargetSaved = { };
--UniTargetSaved.Channel = PARTY;
UniTargetSaved.Button = 1;
UniTargetSaved.Chatprint = 0;
UniTargetSaved.ButtonLock = 1;


function UniTarget_OnLoad()
	SlashCmdList["UNITARGET"] = function(msg)
		UniTarget_Command(msg);
	end
	
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("UNIT_NAME_UPDATE");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");	
end

function UniTarget_OnEvent()
	if (event=="UNIT_NAME_UPDATE") or (event=="PLAYER_ENTERING_WORLD") then
		local UplayerName = UnitName("player");
		if (UniTarget_NameRegistered == 1) then
			return;
		end
			-- If the player has no name yet, then check again later
		if (UniTarget_NameRegistered == 0) then
			if (UplayerName == nil) or (UplayerName == UNKNOWNOBJECT) or (UplayerName == UNKNOWNBEING) then
				return;
			else
				UIErrorsFrame:AddMessage("UniTarget v"..UNITARGETVERSION.." has loaded.", 1.0, 0.0, 0.0, 1.0, 30);
				if( DEFAULT_CHAT_FRAME ) then
					DEFAULT_CHAT_FRAME:AddMessage("UniTarget v"..UNITARGETVERSION.." has loaded.", 0.9, 0.25, 1.0);
				end
				UniTarget_NameRegistered = 1;
			end
		end
	end
	
	if(event == "VARIABLES_LOADED") then
		if (myAddOnsFrame) then
			myAddOnsList.UniTarget = {name = UNITARGETNAME, description = UNITARGETDESC, version = UNITARGETVERSION, category = MYADDONS_CATEGORY_COMBAT, frame = UNITARGETFRAME};
		end
	end

	--if (event == "PLAYER_TARGET_CHANGED") then
	--	UniTargetButton_OnEvent();
	--end
end

------------------------------------------------------------------------------------------------
-- Slash Command
------------------------------------------------------------------------------------------------

function UniTarget_Command(command)
	
	local i,j, cmd, param = string.find(command, "^([^ ]+) (.+)$");
	if (not cmd) then cmd = command; end
	if (not cmd) then cmd = ""; end
	--if (not param) then param = ""; end
	
	if ( cmd and strlen(cmd) > 0 ) then
		cmd = strlower(cmd);
	end
	if ((cmd == "") or (cmd == "help")) then
		Uni_ChatPrint(">");
		local index, subcmdUsage;
			for index, subcmdUsage in UNI_UNITARGETUSAGE_SUBCMD do
				if (subcmdUsage) then
					Uni_ChatPrint(subcmdUsage);
				end
			end
	--elseif (cmd == "channel") then
	--	if (param) then
	-- Possibly need to put strlower(param) in here somewhere, not sure.
	--		if ( param == "party" ) then
	--			UniTargetSaved.Channel = PARTY;
	--			return;
	--		elseif ( param == "guild" ) then
	--			UniTargetSaved.Channel = GUILD;
	--			return;
	--		else
	--			UniTargetSaved.Channel = param
	--		end
	--	else
	--		Uni_ChatPrint(">");
	--		local index, subcmdUsage;
	--		for index, subcmdUsage in UNI_UNITARGETCHANNEL_SUBCMD do
	--			if (subcmdUsage) then
	--				Uni_ChatPrint(subcmdUsage);
	--			end
	--		end
	--	end
	elseif (cmd == "target") then
		if (param) then
			if ( param == "party" ) then
				UniHelp_OnKeypressOne();
				return;
			elseif ( param == "guild" ) then
				UniHelp_OnKeypressTwo();
				return;
			elseif ( param == "officer" ) then
				UniHelp_OnKeypressThree();
				return;
			elseif ( param == "self" ) then
				UniHelp_OnKeypressFour();
				return;
			else
				Uni_ChatPrint(">");
				local index, subcmdUsage;
				for index, subcmdUsage in UNI_UNITARGET_SUBCMD do
				if (subcmdUsage) then
					Uni_ChatPrint(subcmdUsage);
				end
				end
			end
		else
			Uni_ChatPrint(">");
			local index, subcmdUsage;
			for index, subcmdUsage in UNI_UNITARGET_SUBCMD do
			if (subcmdUsage) then
				Uni_ChatPrint(subcmdUsage);
			end
			end
		end
	elseif (cmd == "button") then
		if (param) then
			if ( param == "show" ) then
				UniTargetButton:Show();
				UniTargetSaved.Button = 1;
				return;
			elseif ( param == "hide" ) then
				UniTargetButton:Hide();
				UniTargetSaved.Button = 0;
				return;
			elseif ( param == "status" ) then
				if (UniTargetSaved.Button == 1) then
					UniTar_ChatPrint(">");
					UniTar_ChatPrint("Uni Target Button is enabled.");
					return;
				elseif (UniTargetSaved.Button == 0) then
					UniTar_ChatPrint(">");
					UniTar_ChatPrint("Uni Target Button is disabled.");
				else
					UniTar_ChatPrint(">");
					UniTar_ChatPrint("Not sure what's going on, blame Uni (or at least tell him).");
				end
			elseif ( param == "chatprint") then
				if (UniTargetSaved.Chatprint == 1) then
					UniTargetSaved.Chatprint = 0;
					UniTar_ChatPrint("Clicks will no longer do a generic chat-printout, just in the editbox");
				else 
					if (UniTargetSaved.Chatprint == 0) or not (UniTargetSaved.Chatprint) then
						UniTargetSaved.Chatprint = 1;
						UniTar_ChatPrint("Clicks will do a generic chat-printout as well as the editbox");
					end
				end
			elseif ( param == "reset" ) then
				UniTargetButton_Reset();
				return;
			elseif ( param == "lock" ) then
				UniTargetSaved.ButtonLocked = 1;
				return;
			elseif ( param == "unlock" ) then
				UniTargetSaved.ButtonLocked = 0;
				return;
			else
				UniTar_ChatPrint(">");
				UniTar_ChatPrint("Usage:");
				UniTar_ChatPrint("  |cffffffff/UniTarget button show|r - shows the target button next to the target frame (moveable).");
				UniTar_ChatPrint("  |cffffffff/UniTarget button hide|r - hides the target button.");
				UniTar_ChatPrint("  |cffffffff/UniTarget button status|r - shows the current status.");
				UniTar_ChatPrint("  |cffffffff/UniTarget button lock/unlock|r - locks or unlocks the button.");
				UniTar_ChatPrint("  |cffffffff/UniTarget button chatprint|r - toggles whether chatprint as well as insert into edit box.");
			end
		else
			UniTar_ChatPrint(">");
			UniTar_ChatPrint("Usage:");
			UniTar_ChatPrint("  |cffffffff/UniTarget button show|r - shows the target button next to the target frame (moveable).");
			UniTar_ChatPrint("  |cffffffff/UniTarget button hide|r - hides the target button.");
			UniTar_ChatPrint("  |cffffffff/UniTarget button status|r - shows the current status.");
			UniTar_ChatPrint("  |cffffffff/UniTarget button lock/unlock|r - locks or unlocks the button.");
			UniTar_ChatPrint("  |cffffffff/UniTarget button chatprint|r - toggles whether chatprint as well as insert into edit box.");
		end
	else
		UniTar_ChatPrint(">");
		UniTar_ChatPrint("Either you're a muppet, or Unique is (odds are evens).");
		UniTar_ChatPrint("I don't recognise command: '"..cmd.."'");
	end
end

------------------------------------------------------------------------------------------------
-- Button Showing, Moving, Locking & OnClick Text
------------------------------------------------------------------------------------------------

function UniTargetButton_OnLoad()
	if ((UniTargetSaved.Button == 1) and (UnitName("target") ~= nil)) then
		UniTargetButton:Show();
	else
		UniTargetButton:Hide();
	end	
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
end

function UniTargetButton_OnEvent()
	if (event == "PLAYER_TARGET_CHANGED") then
		if ((UniTargetSaved.Button == 1) and (UnitName("target") ~= nil)) then
			UniTargetButton:Show();
		else
			UniTargetButton:Hide();
		end
	end
end

function UniTargetButton_Reset()
	if (UniTargetSaved.Button == 1) then
		UniTargetButton:ClearAllPoints();
		UniTargetButton:SetPoint("TOP","UIParent","TOP",-80,-65);
		UniTargetSaved.ButtonLocked = 1;
		UniTargetButton:Show();			

	end 	
end

--function UniTargetButton_OnDragStart()
--	if(UniTargetSaved.ButtonLocked == 0 and UniTargetButton:IsVisible()) then
--		UniTargetButton:StartMoving();
--	end
--end

function UniTargetButton_OnDragStop()
	if(UniTargetSaved.ButtonLocked == 0 and UniTargetButton:IsVisible()) then
		UniTargetButton:StopMovingOrSizing();
	end
end

function UniTargetButton_OnClick(button)

	--if not (IsShiftKeyDown()) then
		if (button == "LeftButton") then
			--local UNITARCHANNEL = UniTargetSaved.Channel;
			if (UnitName("target") ~= nil) then
				if not (UnitInParty("target")) then
					local UniTarHealth = UnitHealth("target");
					local UniTarName = UnitName("target");
					if ( GetGuildInfo("target") ~= nil ) then
						UniTarName = format(UniTarName.." of the guild \'"..GetGuildInfo("target").."\'.");
					end
					local UniTarLvl = 0;
					if ( UnitLevel("target") == -1 ) then
						UniTarLvl = "??";
					else
					UniTarLvl = UnitLevel("target");
					end
					if ( UnitClassification("target") == "elite") then
						UniTarLvl = format(UniTarLvl.." (elite)")
					end
					local UniTarClass = UnitClass("target");
					local UniTarRace = 0;
					if ( UnitRace("target") ~= nil ) then
						UniTarRace = UnitRace("target");
					else
						UniTarRace = "(Race Unknown)";
					end
					
					ChatFrameEditBox:Insert("Target: "..UniTarName.." (Lvl: "..UniTarLvl.." "..UniTarRace.." "..UniTarClass..", "..UniTarHealth.."% Health)");
					if (UniTargetSaved.Chatprint == 1) then
						UniTar_ChatPrint("Target: "..UniTarName.." (Lvl: "..UniTarLvl.." "..UniTarRace.." "..UniTarClass..", "..UniTarHealth.."% Health)");
					else
					end
				else
					local UniTarHealth = UnitHealth("target");
					local UniTarName = UnitName("target");
					if ( GetGuildInfo("target") ~= nil ) then
						UniTarName = format(UniTarName.." of the guild \'"..GetGuildInfo("target").."\'.");
					end
					local UniTarLvl = 0;
					if ( UnitLevel("target") == -1 ) then
						UniTarLvl = "??";
					else
						UniTarLvl = UnitLevel("target");
					end
					if ( UnitClassification("target") == "elite") then
						UniTarLvl = format(UniTarLvl.." (elite)")
					end
					local UniTarClass = UnitClass("target");
					local UniTarRace = 0;
					if ( UnitRace("target") ~= nil ) then
						UniTarRace = UnitRace("target");
					else
						UniTarRace = "(Race Unknown)";
					end
						
					ChatFrameEditBox:Insert("Target: "..UniTarName.." (Lvl: "..UniTarLvl.." "..UniTarRace.." "..UniTarClass..", "..UniTarHealth.."/"..UnitHealthMax("target").." Health)");
					if (UniTargetSaved.Chatprint == 1) then
						UniTar_ChatPrint("Target: "..UniTarName.." (Lvl: "..UniTarLvl.." "..UniTarRace.." "..UniTarClass..", "..UniTarHealth.."/"..UnitHealthMax("target").." Health)");
					else
					end
				end
			end
		else 			
		end
	--end
end

------------------------------------------------------------------------------------------------
-- Message-processing function to make my life easier :P
------------------------------------------------------------------------------------------------

function UniTar_ChannelMessage(message, channel)
	SendChatMessage(message, channel)
end

function UniTar_ChatPrint(str)
	if ( DEFAULT_CHAT_FRAME ) then 
		DEFAULT_CHAT_FRAME:AddMessage(str, 1.0, 0.5, 0.25);
	end
end

------------------------------------------------------------------------------------------------
-- Keybind Text
------------------------------------------------------------------------------------------------

function UniTarget_OnKeypressOne()
	if (UnitName("target") ~= nil) then
		if not (UnitInParty("target")) then
			local UniTarHealth = UnitHealth("target");
			local UniTarName = UnitName("target");
			if ( GetGuildInfo("target") ~= nil ) then
				UniTarName = format(UniTarName.." of the guild \'"..GetGuildInfo("target").."\'.");
			end
			local UniTarLvl = 0;
			if ( UnitLevel("target") == -1 ) then
				UniTarLvl = "??";
			else
				UniTarLvl = UnitLevel("target");
			end
			if ( UnitClassification("target") == "elite") then
				UniTarLvl = format(UniTarLvl.." (elite)")
			end
			local UniTarClass = UnitClass("target");
			local UniTarRace = 0;
			if ( UnitRace("target") ~= nil ) then
				UniTarRace = UnitRace("target");
			else
				UniTarRace = "(Race Unknown)";
			end
				
			UniTar_ChannelMessage("Target: "..UniTarName.." (Lvl: "..UniTarLvl.." "..UniTarRace.." "..UniTarClass..", "..UniTarHealth.."% Health)", PARTY);
		else
			local UniTarHealth = UnitHealth("target");
			local UniTarName = UnitName("target");
			if ( GetGuildInfo("target") ~= nil ) then
				UniTarName = format(UniTarName.." of the guild \'"..GetGuildInfo("target").."\'.");
			end
			local UniTarLvl = 0;
			if ( UnitLevel("target") == -1 ) then
				UniTarLvl = "??";
			else
				UniTarLvl = UnitLevel("target");
			end
			if ( UnitClassification("target") == "elite") then
				UniTarLvl = format(UniTarLvl.." (elite)")
			end
			local UniTarClass = UnitClass("target");
			local UniTarRace = 0;
			if ( UnitRace("target") ~= nil ) then
				UniTarRace = UnitRace("target");
			else
				UniTarRace = "(Race Unknown)";
			end
				
			UniTar_ChannelMessage("Target: "..UniTarName.." (Lvl: "..UniTarLvl.." "..UniTarRace.." "..UniTarClass..", "..UniTarHealth.."/"..UnitHealthMax("target").." Health)", PARTY);
		end
	end
end

function UniTarget_OnKeypressTwo()
	if (UnitName("target") ~= nil) then
		if not (UnitInParty("target")) then
			local UniTarHealth = UnitHealth("target");
			local UniTarName = UnitName("target");
			if ( GetGuildInfo("target") ~= nil ) then
				UniTarName = format(UniTarName.." of the guild \'"..GetGuildInfo("target").."\'.");
			end
			local UniTarLvl = 0;
			if ( UnitLevel("target") == -1 ) then
				UniTarLvl = "??";
			else
				UniTarLvl = UnitLevel("target");
			end
			if ( UnitClassification("target") == "elite") then
				UniTarLvl = format(UniTarLvl.." (elite)")
			end
			local UniTarClass = UnitClass("target");
			local UniTarRace = 0;
			if ( UnitRace("target") ~= nil ) then
				UniTarRace = UnitRace("target");
			else
				UniTarRace = "(Race Unknown)";
			end
				
			UniTar_ChannelMessage("Target: "..UniTarName.." (Lvl: "..UniTarLvl.." "..UniTarRace.." "..UniTarClass..", "..UniTarHealth.."% Health)", GUILD);
		else
			local UniTarHealth = UnitHealth("target");
			local UniTarName = UnitName("target");
			if ( GetGuildInfo("target") ~= nil ) then
				UniTarName = format(UniTarName.." of the guild \'"..GetGuildInfo("target").."\'.");
			end
			local UniTarLvl = 0;
			if ( UnitLevel("target") == -1 ) then
				UniTarLvl = "??";
			else
				UniTarLvl = UnitLevel("target");
			end
			if ( UnitClassification("target") == "elite") then
				UniTarLvl = format(UniTarLvl.." (elite)")
			end
			local UniTarClass = UnitClass("target");
			local UniTarRace = 0;
			if ( UnitRace("target") ~= nil ) then
				UniTarRace = UnitRace("target");
			else
				UniTarRace = "(Race Unknown)";
			end
				
			UniTar_ChannelMessage("Target: "..UniTarName.." (Lvl: "..UniTarLvl.." "..UniTarRace.." "..UniTarClass..", "..UniTarHealth.."/"..UnitHealthMax("target").." Health)", GUILD);
		end
	end
end

function UniTarget_OnKeypressThree()
	if (UnitName("target") ~= nil) then
		if not (UnitInParty("target")) then
			local UniTarHealth = UnitHealth("target");
			local UniTarName = UnitName("target");
			if ( GetGuildInfo("target") ~= nil ) then
				UniTarName = format(UniTarName.." of the guild \'"..GetGuildInfo("target").."\'.");
			end
			local UniTarLvl = 0;
			if ( UnitLevel("target") == -1 ) then
				UniTarLvl = "??";
			else
				UniTarLvl = UnitLevel("target");
			end
			if ( UnitClassification("target") == "elite") then
				UniTarLvl = format(UniTarLvl.." (elite)")
			end
			local UniTarClass = UnitClass("target");
			local UniTarRace = 0;
			if ( UnitRace("target") ~= nil ) then
				UniTarRace = UnitRace("target");
			else
				UniTarRace = "(Race Unknown)";
			end

			UniTar_ChannelMessage("Target: "..UniTarName.." (Lvl: "..UniTarLvl.." "..UniTarRace.." "..UniTarClass..", "..UniTarHealth.."% Health)", "OFFICER");
		else
			local UniTarHealth = UnitHealth("target");
			local UniTarName = UnitName("target");
			if ( GetGuildInfo("target") ~= nil ) then
				UniTarName = format(UniTarName.." of the guild \'"..GetGuildInfo("target").."\'.");
			end
			local UniTarLvl = 0;
			if ( UnitLevel("target") == -1 ) then
				UniTarLvl = "??";
			else
				UniTarLvl = UnitLevel("target");
			end
			if ( UnitClassification("target") == "elite") then
				UniTarLvl = format(UniTarLvl.." (elite)")
			end
			local UniTarClass = UnitClass("target");
			local UniTarRace = 0;
			if ( UnitRace("target") ~= nil ) then
				UniTarRace = UnitRace("target");
			else
				UniTarRace = "(Race Unknown)";
			end

			UniTar_ChannelMessage("Target: "..UniTarName.." (Lvl: "..UniTarLvl.." "..UniTarRace.." "..UniTarClass..", "..UniTarHealth.."/"..UnitHealthMax("target").." Health)", "OFFICER");
		end
	end
end

function UniTarget_OnKeypressFour()
	if (UnitName("target") ~= nil) then
		if not (UnitInParty("target")) then
			local UniTarHealth = UnitHealth("target");
			local UniTarName = UnitName("target");
			if ( GetGuildInfo("target") ~= nil ) then
				UniTarName = format(UniTarName.."|cff66ccff of the guild \'|cffffffff"..GetGuildInfo("target").."|cff66ccff\'.");
			end
			local UniTarLvl = 0;
			if ( UnitLevel("target") == -1 ) then
				UniTarLvl = "??";
			else
				UniTarLvl = UnitLevel("target");
			end
			if ( UnitClassification("target") == "elite") then
				UniTarLvl = format(UniTarLvl.." (elite)")
			end
			local UniTarClass = UnitClass("target");
			local UniTarRace = 0;
			if ( UnitRace("target") ~= nil ) then
				UniTarRace = UnitRace("target");
			else
				UniTarRace = "(Race Unknown)";
			end
				
			UniTar_ChatPrint("|cff66ccffTarget: |cffffffff"..UniTarName.."|cff66ccff (Lvl: |cffffffff"..UniTarLvl.."|cff66ccff "..UniTarRace.." "..UniTarClass..", |cffffffff"..UniTarHealth.."% |cff66ccffHealth)");
		else
			local UniTarHealth = UnitHealth("target");
			local UniTarName = UnitName("target");
			if ( GetGuildInfo("target") ~= nil ) then
				UniTarName = format(UniTarName.."|cff66ccff of the guild \'|cffffffff"..GetGuildInfo("target").."|cff66ccff\'.");
			end
			local UniTarLvl = 0;
			if ( UnitLevel("target") == -1 ) then
				UniTarLvl = "??";
			else
				UniTarLvl = UnitLevel("target");
			end
			if ( UnitClassification("target") == "elite") then
				UniTarLvl = format(UniTarLvl.." (elite)")
			end
			local UniTarClass = UnitClass("target");
			local UniTarRace = 0;
			if ( UnitRace("target") ~= nil ) then
				UniTarRace = UnitRace("target");
			else
				UniTarRace = "(Race Unknown)";
			end
				
			UniTar_ChatPrint("|cff66ccffTarget: |cffffffff"..UniTarName.."|cff66ccff (Lvl: |cffffffff"..UniTarLvl.."|cff66ccff "..UniTarRace.." "..UniTarClass..", |cffffffff"..UniTarHealth.."/"..UnitHealthMax("target").."|cff66ccff Health)");
		end
	end
end